#define BAUDRATE 300

void initTimer1()
{
  TCCR1B &= ~(1<<WGM13); //Mode 4
  TCCR1B |= (1<<WGM12);
  TCCR1A &= ~(1<<WGM11);
  TCCR1A &= ~(1<<WGM10);
    
  //Vorteilung 1: 16000000Hz
  TCCR1B &= ~(1<<CS12);
  TCCR1B &= ~(1<<CS11);
  TCCR1B |= (1<<CS10);
    
  //f = fclk/(2*N*(OCR1A+1))
  //OCR1A = (fclk/(f*2*N))-1
  //OCR1A = 8000000/440 - 1 ==  18181
  //KORRIGIERT:
  //********************************
  //OCR1A = 4000000/440 - 1 ==  9091
  //OCR1A = 16000000/(f*4*N) - 1 ==  9091
  //********************************
  //OCR1A=9091;  //0,5Hz == 4 Schläge!
//  OCR1A=132;  //0,5Hz == 4 Schläge!
  OCR1A=264;  //0,5Hz == 4 Schläge!
  
  //Toggle auf OC1A:
  TCCR1A &= ~(1<<COM1A1);
  TCCR1A |=  (1<<COM1A0);
  pinMode(9,OUTPUT);      
}


void setup() 
{
    //Motortest bei D11, D12:
    //pinMode(11,OUTPUT);
    pinMode(12,OUTPUT);
  
    //digitalWrite(11,HIGH);
    digitalWrite(12,HIGH);
  
    analogWrite(11,15);
  
    initTimer1();
    //PB2 sicher deaktivieren, da als toter Pin für IR-Anode benötigt:
    DDRB &= ~0b00000100;

    //TSOP 31230 aktivieren:
    //Spannungsversorgung IR-Sensor:
    pinMode(22,OUTPUT);  //A4
    pinMode(23,OUTPUT);  //A5  
    digitalWrite(22,LOW);
    digitalWrite(23,HIGH);
    

    Serial.begin(BAUDRATE);  //Kabelverbindung
    Serial1.begin(BAUDRATE); //Infrarot-Verbindung
    
}

void loop() 
{
     //Zeichen weiterleiten zur IR-Diode:
     if(Serial.available())//Senden
     {
           Serial1.write(Serial.read());
     }
     if(Serial1.available()) //Empfangen
     {
           Serial.write(Serial1.read());
     }
}
